Index: trunk/LMDZ.TITAN/libf/phytitan/phytrac.F
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/phytrac.F	(revision 1055)
+++ trunk/LMDZ.TITAN/libf/phytitan/phytrac.F	(revision 1056)
@@ -16,5 +16,5 @@
 c nqmax--------input-I-nombre de traceurs (total)
 c nmicro-------input-I-nombre de traceurs microphysiques !! doivent etre toujours en premiers!!
-c ptimestep----input-R-pas d'integration pour la physique (seconde)
+c ptimestep----input-R-pas d integration pour la physique (seconde)
 c appkim-------input-I-appel a la chimie
 c dtkim--------input-R-pas de temps chimique (seconde)
@@ -40,4 +40,8 @@
       USE infotrac
       use dimphy
+      USE common_mod, only: rmcbar,xfbar,ncount,
+     &      flxesp_i,tau_drop,tau_aer,solesp,precip,
+     &      evapch4,occcld_m,occcld,satch4,satc2h6,satc2h2,rmcloud
+      USE moyzon_mod
       IMPLICIT none
 #include "dimensions.h"
@@ -46,6 +50,6 @@
 #include "microtab.h"
 #include "varmuphy.h"
-#include "diagmuphy.h"
 #include "itemps.h"
+#include "logic.h"
 
 c======================================================================
@@ -72,13 +76,4 @@
       REAL prec(klon,5)
 
-c  ASTUCE POUR EVITER klon... EN ATTENDANT MIEUX
-      INTEGER   ngrid,NLAYER
-      PARAMETER (ngrid=(jjm-1)*iim+2)  ! = klon
-      PARAMETER (NLAYER=llm)           ! = klev
-* common relatifs au nuages
-      real rmcbar(ngrid,NLAYER),xfbar(ngrid,NLAYER,4) 
-      integer ncount(ngrid,NLAYER)
-      COMMON/rnuabar/ncount,rmcbar,xfbar
-
       REAL rcloud(klon,klev,nrad),xfrac(klon,klev,4)
 
@@ -91,14 +86,11 @@
 
 c grandeurs en moyennes zonales
-      REAL zplev(jjm+1,klev+1),zplay(jjm+1,klev),ztsol(jjm+1)
-      REAL zzlev(jjm+1,klev+1),zzlay(jjm+1,klev)
-      REAL ztemp(jjm+1,klev),zmu0(jjm+1),zfract(jjm+1)
+      REAL zplev(klon,klev+1),zplay(klon,klev)
+      REAL zzlev(klon,klev+1),zzlay(klon,klev)
+      REAL ztemp(klon,klev), delpbar(klon,klev)
       real temp_eq(klev),press_eq(klev)
-      REAL zqaer(jjm+1,klev,nqmax)    ! et non nmicro... Permet nmicro=0.
-      REAL zqaer0(jjm+1,klev,nqmax) 
-      REAL zdqmufi(jjm+1,klev,nqmax)
-      REAL ychim(jjm+1,klev,nqmax-nmicro) 
-      REAL zgaz1(jjm+1,klev),zgaz2(jjm+1,klev),zgaz3(jjm+1,klev)
-      REAL zgaz10(jjm+1,klev),zgaz20(jjm+1,klev),zgaz30(jjm+1,klev)
+      REAL qaer0bar(klon,klev,nqmax)   ! et non nmicro... Permet nmicro=0.
+      REAL zdqmufi(klon,klev,nqmax)
+      REAL ychim(klon,klev,nqmax-nmicro) 
 c La saturation n est calculee qu une seule fois: sauvegarde qysat
 c La chimie n est pas calculee tous les pas, il faut donc
@@ -109,8 +101,4 @@
       integer      i,j,k,l,iq,ig0
       
-      REAL zprec(jjm+1,5),zsolesp(jjm+1,klev,3),
-     &     zflxesp_i(jjm+1,klev,3)
-      REAL ztau_drop(jjm+1,klev),ztau_aer(jjm+1,klev,nrad)
-c
 c    indice des esp chimiques utilisees dans la microfi  
       integer icldch4,icldc2h6,icldc2h2
@@ -121,7 +109,4 @@
       REAL tmp,ex,kmin,kmax,dqsq
       REAL dqch4
-c      REAL ch4(jjm+1),ch4b(jjm+1),dch4(jjm+1),ch4c(jjm+1,llm)
-c       integer ich4
-c       common/ch4ind/ich4
 
 c======================================================================
@@ -129,5 +114,5 @@
 
       if (firstcall) then
-       allocate(qysat(klev,nqmax-nmicro),pdyfi(jjm+1,klev,nqmax-nmicro))
+       allocate(qysat(klev,nqmax-nmicro),pdyfi(klon,klev,nqmax-nmicro))
 
 c  -------- Quelques verifications au demarrage sur les tailles des tableaux.
@@ -156,5 +141,5 @@
          ENDIF
 
-      endif
+      endif  ! firstcall
 
 c RAZ des sorties : les moyennes se font directement dans IOIPSL :
@@ -177,84 +162,56 @@
 c   -------------------
 c   Gestion de la temperature et de la pression :
+c   Utilisation des moyennes zonales:
+
 c   soit la chimie est active, soit la microphysique se fait en 2D.
       IF (chimi.or.microfi.eq.1) THEN
- 
-        zplev = 0.0
-        zplay = 0.0
-        zzlev = 0.0
-        zzlay = 0.0
-        ztemp = 0.0
-        zqaer = 0.0
+        zplev(:,:) = zplevbar(:,:)
+        zplay(:,:) = zplaybar(:,:)
+        zzlev(:,:) = zzlevbar(:,:)
+        zzlay(:,:) = zzlaybar(:,:)
+        ztemp(:,:) = ztfibar(:,:)
         ychim = 0.0
-        zmu0  = 0.0
-        zfract= 0.0
-        zgaz1 = 0.0
-        zgaz2 = 0.0
-        zgaz3 = 0.0
-        zprec = 0.0
-        zflxesp_i = 0.0
-        ztau_drop = 0.0 
-        ztau_aer  = 0.0
-        zsolesp   = 0.0
-   
-       do l=1,llm+1
-         zplev(1,l) = pplev(1,l)
-         zzlev(1,l) = pzlev(1,l)
-	 do j=2,jjm
-	    ig0=1+(j-2)*iim
-	    do i=1,iim
-	       zplev(j,l) = zplev(j,l) + pplev(ig0+i,l)/iim
-               zzlev(j,l) = zzlev(j,l) + pzlev(ig0+i,l)/iim
-	    enddo
-	 enddo
-         zplev(jjm+1,l) = pplev(klon,l)
-         zzlev(jjm+1,l) = pzlev(klon,l)
-       enddo
-
-       do l=1,llm
-         ztemp(1,l) = ptemp(1,l)
-         zplay(1,l) = pplay(1,l)
-         zzlay(1,l) = pzlay(1,l)
-	 do j=2,jjm
-	    ig0=1+(j-2)*iim
-	    do i=1,iim
-	       ztemp(j,l) = ztemp(j,l) + ptemp(ig0+i,l)/iim
-	       zplay(j,l) = zplay(j,l) + pplay(ig0+i,l)/iim
-               zzlay(j,l) = zzlay(j,l) + pzlay(ig0+i,l)/iim
-	    enddo
-	 enddo
-         ztemp(jjm+1,l) = ptemp(klon,l)
-         zplay(jjm+1,l) = pplay(klon,l)
-         zzlay(jjm+1,l) = pzlay(klon,l)
-	 temp_eq  = ztemp((jjm+1)/2,:)
-	 press_eq = zplay((jjm+1)/2,:)/100. ! en mbar
-       enddo
-
-      ENDIF   ! chimi or microfi=1
-
-c   -----------------------------
-c   Gestion des variables de la microphysique :
-c
-c   -------------------
-      if (microfi.ge.1) then
-
-c   Traceurs microphysiques: passage en extensif: n/kg --> n/m^2 (2D ou 3D passage obligatoire)
-      DO iq=1,nmicro
-c        print*,tname(iq)
+      ENDIF
+
+c  Si la microphysique est faite en 2D:
+      IF (microfi.eq.1) THEN
         DO l=1,llm
           DO i = 1, klon
-            qaer(i,l,iq) = tr_seri(i,l,iq)*delp(i,l)/RG
+            delpbar(i,l) = zplevbar(i,l) - zplevbar(i,l+1)
           ENDDO
         ENDDO
-      ENDDO 
-c     copie du tableau de traceur :
-      qaer0(:,:,:)=qaer(:,:,:)
-c
+c   Traceurs microphysiques: passage en extensif: n/kg --> n/m^2
+        DO iq=1,nmicro
+         qaer(:,:,iq) = zqfibar(:,:,iq)*delpbar(:,:)/RG
+         qaer0(:,:,iq)= tr_seri(:,:,iq)*delp(:,:)/RG
+         qaer0bar(:,:,iq) = qaer(:,:,iq)
+        ENDDO
+      ENDIF
+
+c  Si la microphysique est faite en 3D:
+      IF (microfi.eq.2) THEN
+        zplev(:,:) = pplev(:,:)
+        zplay(:,:) = pplay(:,:)
+        zzlev(:,:) = pzlev(:,:)
+        zzlay(:,:) = pzlay(:,:)
+        ztemp(:,:) = ptemp(:,:)    
+c   Traceurs microphysiques: passage en extensif: n/kg --> n/m^2
+        DO iq=1,nmicro
+         qaer(:,:,iq) = tr_seri(:,:,iq)*delp(:,:)/RG
+         qaer0(:,:,iq)= tr_seri(:,:,iq)*delp(:,:)/RG
+        ENDDO
+      ENDIF
+
+      do l=1,llm
+	 temp_eq  = tmoy
+	 press_eq = playmoy/100. ! en mbar
+      enddo
+
 c   -------------------
 c    Extraction des gaz pour les nuages
-c
+      IF ((microfi.ge.1).and.(clouds.eq.1)) THEN
+
 c     recuperation des indices des gaz qui nous interesse       
       if (firstcall) then
-        if (clouds.eq.1) then
           icldch4=-1
           icldc2h6=-1
@@ -279,5 +236,4 @@
             STOP
           endif
-        endif    ! clouds=1
       endif      ! firstcall
 
@@ -286,7 +242,5 @@
 c     On le fait ici pour les sortir dans physiq.F sans avoir a surcharger la routine. 
 c     Elles passent ensuite dans un common pour passer dans les I/O.
-c
-c-------------------------------------------
-      IF (clouds.eq.1) THEN
+
         DO l=1,llm
           DO i = 1, klon
@@ -299,97 +253,34 @@
             call c2h2sat(ptemp(i,l),pplay(i,l),tmp)
             satc2h2(i,l) =tr_seri(i,l,icldc2h2)/(tmp*28./26.)
-   
           ENDDO
         ENDDO
 
 c   Copie des gaz (en 3D)  <== UNIQUEMENT SI ON FAIT DES NUAGES
-        gaz1(:,:) = tr_seri(:,:,icldch4)
-        gaz2(:,:) = tr_seri(:,:,icldc2h6)
-        gaz3(:,:) = tr_seri(:,:,icldc2h2)
-
-      ENDIF      ! clouds=1
+        if (moyzon_mu) then
+         gaz1(:,:) = zqfibar(:,:,icldch4)
+         gaz2(:,:) = zqfibar(:,:,icldc2h6)
+         gaz3(:,:) = zqfibar(:,:,icldc2h2)
+        else
+         gaz1(:,:) = tr_seri(:,:,icldch4)
+         gaz2(:,:) = tr_seri(:,:,icldc2h6)
+         gaz3(:,:) = tr_seri(:,:,icldc2h2)
+        endif
         
-      endif      ! microfi.ge.1
-
-c     -------------------
-c     Si microfi = 1 on est en 2D :
-c     conversion des inputs de muphys
-      IF (microfi.eq.1) THEN
-
-         zmu0(1)   = pmu0(1)
-         zfract(1) = pfract(1)
-	 do j=2,jjm
-	    ig0=1+(j-2)*iim
-	    do i=1,iim
-	       zmu0(j)   = zmu0(j)   + pmu0(ig0+i)/iim
-	       zfract(j) = zfract(j) + pfract(ig0+i)/iim
-	    enddo
-	 enddo
-         zmu0(jjm+1)   = pmu0(klon)
-         zfract(jjm+1) = pfract(klon)
-c
-c     traceurs 3D --> 2D
-c 
-      do iq=1,nqmax
-       do l=1,llm
-         zqaer(1,l,iq) = qaer(1,l,iq)
-	 do j=2,jjm
-	    ig0=1+(j-2)*iim
-	    do i=1,iim
-	       zqaer(j,l,iq) = zqaer(j,l,iq) + qaer(ig0+i,l,iq)/iim
-	    enddo
-	 enddo
-         zqaer(jjm+1,l,iq) = qaer(klon,l,iq)
-       enddo
-      enddo
-c       copie du tableau de traceur
-        zqaer0(:,:,:) = zqaer(:,:,:)
-c 
-c      gaz 3D --> 2D    <=== UNIQUEMENT SI ON FAIT DES NUAGES.
-c
-        if (clouds.eq.1) then
-          do l=1,llm
-            zgaz1(1,l) = gaz1(1,l)
-            zgaz2(1,l) = gaz2(1,l)
-            zgaz3(1,l) = gaz3(1,l)
-            do j=2,jjm
-              ig0=1+(j-2)*iim
-              do i=1,iim
-                zgaz1(j,l) = zgaz1(j,l) + gaz1(ig0+i,l)/iim
-                zgaz2(j,l) = zgaz2(j,l) + gaz2(ig0+i,l)/iim
-                zgaz3(j,l) = zgaz3(j,l) + gaz3(ig0+i,l)/iim
-              enddo
-            enddo
-            zgaz1(jjm+1,l) = gaz1(klon,l)
-            zgaz2(jjm+1,l) = gaz2(klon,l)
-            zgaz3(jjm+1,l) = gaz3(klon,l)
-          enddo
- 
-          zgaz10=zgaz1
-          zgaz20=zgaz2
-          zgaz30=zgaz3
-        endif ! clouds=1
-
-      endif   ! microfi=1
+      endif      ! microfi.ge.1 + clouds.eq.1
+c   -------------------
 
 c AUTRES TRACEURS
       
       if (nqmax.gt.nmicro) then
-      do iq=nmicro+1,nqmax
-       do l=1,llm
-         ychim(1,l,iq-nmicro) = tr_seri(1,l,iq)
-	 do j=2,jjm
-	    ig0=1+(j-2)*iim
-	    do i=1,iim
-	       ychim(j,l,iq-nmicro) = ychim(j,l,iq-nmicro) 
-     .                              + tr_seri(ig0+i,l,iq)/iim
-	    enddo
-	 enddo
-         ychim(jjm+1,l,iq-nmicro) = tr_seri(klon,l,iq)
+       do iq=nmicro+1,nqmax
+        if (moyzon_ch) then
+          ychim(:,:,iq-nmicro) = zqfibar(:,:,iq)
+        else
+          ychim(:,:,iq-nmicro) = tr_seri(:,:,iq)
+        endif
+        nomqy(iq-nmicro) = tname(iq)
+c        print*,iq-nmicro,nomqy(iq-nmicro)
        enddo
-       nomqy(iq-nmicro) = tname(iq)
-c       print*,iq-nmicro,nomqy(iq-nmicro)
-      enddo
-      nomqy(nqmax-nmicro+1) = "HV"
+       nomqy(nqmax-nmicro+1) = "HV"
       endif
 
@@ -416,116 +307,26 @@
        IF (MICROFI.eq.0) THEN
 c        PAS DE MICROPHYSIQUE :
-c        On appelle juste rdf pour creer la grille de rayons.
          IF (firstcall) THEN
           print*,'MICROPHYSIQUE OFF-LINE',MICROFI
-           call rdf()
          ENDIF
-c        NOTES : 
-c        L'appel de rdf ne sert a rien ici mis a part pour le TR. Si cet
-c        appel a deja lieu dans le TR inutile de le refaire ici.
-c        Je ne sais pas exactement comment marche les modules en F90
-c        Mais je recopie les valeurs du common/part/ de rdf pour 
-c        les mettre dans un common interne a la microphysique (voir varmuphy.h)
-c        DONC J'AI BESOIN D'AVOIR ACCES A L'ANCIEN COMMON !!!
-c
-       ELSEIF (MICROFI.eq.1) THEN
-c      MICROPHYSIQUE 2D :
-c      Les input/output comportent le prefixe z pour 2D :)
+       ELSE
          zdqmufi = 0.  ! ne sert que pour chimi pour condensation
-         call muphys(jjm+1,
+         call muphys(klon,
      &        zplev,zplay,zzlev,zzlay,
-     &        ztemp,zqaer,zgaz1,zgaz2,zgaz3,
+     &        ztemp,qaer,gaz1,gaz2,gaz3,
      &        nmicro,ptimestep,
-     &        zmu0,zfract,
+     &        pmu0,pfract,
 c -------- sorties diagnostiques
-     &        zflxesp_i,
-     &        ztau_drop,ztau_aer,
-     &        zsolesp,zprec)
-       ELSE
-c      MICROPHYSIQUE 3D :
-c      Les input sont des champs 3D directement !
-         call muphys(klon,
-     &        pplev,pplay,pzlev,pzlay,
-     &        ptemp,qaer,gaz1,gaz2,gaz3,
-     &        nmicro,ptimestep,
-     &        pmu0,pfract,     
-c ------ sorties diagnostiques
      &        flxesp_i,
      &        tau_drop,tau_aer,
      &        solesp,prec)
-c
+
 c    NOTES :
 c    Ici toutes nos sorties sont des champs 3D...(meme les diagnostiques)
 c    On a rien a faire mis a part copier les dq dans les d_tr
-c
+
        ENDIF
 c       call endtime(tt0,tt1)
 c       ttmuphys=ttmuphys+tt1
-
-c-----------------------------------------------------------------------
-c     Mise a jour des sorties de muphys
-c    -------------
-c       En 2D on copie les sorties de muphys de la grille LATxALT
-c       sur la grille complete. 
-       IF (microfi.eq.1) THEN
-c        precipitations
-         DO l=1,5
-           prec(1,l) = zprec(1,l)
-           ig0 = 2
-           DO j=2,jjm
-             DO i = 1, iim
-               prec(ig0,l) = zprec(j,l)
-               ig0 = ig0 + 1
-             ENDDO
-           ENDDO
-           prec(ig0,l) = zprec(jjm+1,l)
-         ENDDO
-c        taux sedimentation
-         DO l=1,llm
-c          taux sed goutte
-           IF (clouds.eq.1) THEN
-             tau_drop(1,l) = ztau_drop(1,l)
-             ig0 = 2
-             DO j=2,jjm
-               DO i = 1, iim
-                 tau_drop(ig0,l) = ztau_drop(j,l)
-                 ig0 = ig0 + 1
-               ENDDO
-             ENDDO
-             tau_drop(ig0,l) = ztau_drop(jjm+1,l)
-           ENDIF
-c          taux sed aer
-           DO iq=1,nrad
-             tau_aer(1,l,iq)  = ztau_aer(1,l,iq)
-             ig0 = 2
-             DO j=2,jjm
-               DO i = 1, iim
-                 tau_aer(ig0,l,iq)  = ztau_aer(j,l,iq)
-                 ig0 = ig0 + 1
-               ENDDO
-             ENDDO
-             tau_aer(ig0,l,iq) = ztau_aer(jjm+1,l,iq)
-           ENDDO
-         ENDDO
-c        flux glace / production glace
-         IF (clouds.eq.1) THEN
-           DO iq=1,3
-             DO l=1,llm
-               flxesp_i(1,l,iq) = zflxesp_i(1,l,iq)
-               solesp(1,l,iq) = zsolesp(1,l,iq)
-               ig0 = 2
-               DO j=2,jjm
-                 DO i = 1, iim
-                   flxesp_i(ig0,l,iq)=zflxesp_i(j,l,iq)
-                   solesp(ig0,l,iq) = zsolesp(j,l,iq)    
-                   ig0 = ig0 + 1
-                 ENDDO
-               ENDDO
-               flxesp_i(ig0,l,iq)=zflxesp_i(jjm+1,l,iq)
-               solesp(ig0,l,iq) = zsolesp(jjm+1,l,iq)
-             ENDDO
-           ENDDO
-         ENDIF
-       ENDIF
        
 c-----------------------------------------------------------------------
@@ -534,57 +335,20 @@
 c
        IF (clouds.eq.1) THEN
-         IF (microfi.eq.1) THEN
-c          On repasse les gaz en 3D si on a fait de la microphysique en 2D
-           DO l=1,llm
-             gaz1(1,l) = zgaz1(1,l)
-             gaz2(1,l) = zgaz2(1,l)
-             gaz3(1,l) = zgaz3(1,l)
-             ig0 = 2
-             DO j=2,jjm
-               DO i = 1, iim
-                 gaz1(ig0,l) = zgaz1(j,l)* gaz1(ig0,l) /zgaz10(j,l)
-                 gaz2(ig0,l) = zgaz2(j,l)* gaz2(ig0,l) /zgaz20(j,l)
-                 gaz3(ig0,l) = zgaz3(j,l)* gaz3(ig0,l) /zgaz30(j,l)
-                 ig0 = ig0 + 1
-               ENDDO
-             ENDDO
-             gaz1(ig0,l) = zgaz1(jjm+1,l)
-             gaz2(ig0,l) = zgaz2(jjm+1,l)
-             gaz3(ig0,l) = zgaz3(jjm+1,l)
-           ENDDO
-         ENDIF
-c        Mise a jour du reservoir de CH4 (ie : seul le CH4 remplit le reservoir)
-         DO i=1,klon
-            reservoir(i) = reservoir(i)+prec(i,1)
-         ENDDO 
-c        Calcul des sources :
-c        ch4=0.
-c        ch4(1) = gaz1(1,1)
-c         do j=2,jjm
-c           ig0=1+(j-2)*iim
-c           do i=1,iim
-c             ch4(j)= ch4(j) + gaz1(ig0+i,1)/iim
-c           enddo
-c         enddo
-c         ch4(jjm+1) = gaz1(ig0,1)
-
-         CALL sources(klon,klev,ptimestep,z0,
+        IF (microfi.eq.1) THEN
+c        On repasse les gaz en 3D si on a fait de la microphysique en 2D
+         gaz1(:,:)=gaz1(:,:)*tr_seri(:,:,icldch4)/zqfibar(:,:,icldch4)
+         gaz2(:,:)=gaz2(:,:)*tr_seri(:,:,icldc2h6)/zqfibar(:,:,icldc2h6)
+         gaz3(:,:)=gaz3(:,:)*tr_seri(:,:,icldc2h2)/zqfibar(:,:,icldc2h2)
+        ENDIF
+c       Mise a jour du reservoir de CH4 (ie : seul le CH4 remplit le reservoir)
+        DO i=1,klon
+          reservoir(i) = reservoir(i)+prec(i,1)
+        ENDDO 
+
+        CALL sources(klon,klev,ptimestep,z0,
      &                pu,pv,pplev,pzlay,pzlev,
      &                gaz1,gaz2,gaz3,
      &                ftsol,evapch4,reservoir) 
  
-c        ch4b=0.
-c        ch4b(1) = gaz1(1,1)
-c         do j=2,jjm
-c           ig0=1+(j-2)*iim
-c           do i=1,iim
-c             ch4b(j)= ch4b(j) + gaz1(ig0+i,1)/iim
-c           enddo
-c         enddo
-c         ch4b(jjm+1) = gaz1(ig0,1)
-c         do j=1,jjm+1
-c           write(499,*) j,ch4(j),ch4b(j)
-c         enddo
-c         write(499,*) ""
        ENDIF
 c-----------------------------------------------------------------------
@@ -599,5 +363,5 @@
         do iq=1,nqmax-nmicro
            do l=1,llm
-              do j=1,jjm+1
+              do j=1,klon
                  if (ychim(j,l,iq).gt.qysat(l,iq)) then
            zdqmufi(j,l,nmicro+iq)= (-ychim(j,l,iq)+qysat(l,iq)) !delta y
@@ -622,5 +386,5 @@
 c         if (nomqy(iq).eq."CH4") then
 c          do l=1,llm
-c             do j=1,jjm+1
+c             do j=1,klon
 c                if (ychim(j,l,iq).le.0.015) then
 c          zdqmufi(j,l,nmicro+iq)= (-ychim(j,l,iq)+0.015) !delta y
@@ -640,5 +404,5 @@
 c         if (nomqy(iq).eq."C2H2") then
 c          do l=1,llm
-c             do j=1,jjm+1
+c             do j=1,klon
 c                if (ychim(j,l,iq).gt.1.e-5) then
 c          zdqmufi(j,l,nmicro+iq)= (-ychim(j,l,iq)+1.e-5) !delta y
@@ -650,5 +414,5 @@
 c         if (nomqy(iq).eq."C2H6") then
 c          do l=1,llm
-c             do j=1,jjm+1
+c             do j=1,klon
 c                if (ychim(j,l,iq).gt.3.e-5) then
 c          zdqmufi(j,l,nmicro+iq)= (-ychim(j,l,iq)+3.e-5) !delta y
@@ -680,5 +444,5 @@
 c Appel Chimie
 c ------------
-       CALL calchim(nqmax-nmicro,ychim,nomqy,pdecli,lonsol,dtkim,
+       CALL calchim(klon,nqmax-nmicro,ychim,nomqy,pdecli,lonsol,dtkim,
      .              ztemp,zplay,zplev,
      .              pdyfi)   
@@ -701,11 +465,14 @@
 c ---> microphysique 2D
       IF (microfi.eq.1) THEN
-c  on repasse le champ de traceurs en 3D (pas les tendances)
          DO iq=1,nmicro
            DO l=1,llm
-             qaer(1,l,iq) = zqaer(1,l,iq)
-             ig0          = 2
-             DO j=2,jjm
-               DO i = 1, iim
+             DO i=1,klon
+c  on repasse le champ de traceurs en 3D (pas les tendances)
+c qaer est ce qui entre dans muphy, donc la moyenne zonale
+c qaer0 est la valeur initiale du champ
+c qaer0 est la moyenne zonale initiale
+c la variation relative pour une bande de latitude est donc (qaer/qaer0bar)
+c la nouvelle valeur en un point (3D) est donc qaer0*(qaer/qaer0bar)
+c et la tendance: qaer0*(qaer/qaer0bar)-qaer0
 c    un petit patch : 
 c    Si la moyenne zonale au depart est "nulle" :
@@ -714,20 +481,9 @@
 c    Cela permet aussi entre autre d eviter les NaN pour les traceurs des nuages !
 c    (au dessus de la tropo pas de nuages donc qaer(nrad+1:ntype*nrad) = 0 !!!)
-                 IF (zqaer0(j,l,iq).lt.1e-100) THEN
-                   qaer(ig0,l,iq) = zqaer(j,l,iq) 
-                 ELSE
-                   qaer(ig0,l,iq) = zqaer(j,l,iq) *
-     &             qaer0(ig0,l,iq)/zqaer0(j,l,iq)
-                 ENDIF
-                 ig0 = ig0 + 1
-               ENDDO
-             ENDDO
-             qaer(ig0,l,iq) = zqaer(jjm+1,l,iq)
-           ENDDO
-         ENDDO
-c        La tendances correspond a (qaer-qaer0)/ptimestep
-         DO iq=1,nmicro
-           DO i=1,klon
-             DO l=1,llm
+               IF (qaer0bar(i,l,iq).gt.1e-100) THEN
+                   qaer(i,l,iq) = qaer0(i,l,iq) *
+     &             qaer(i,l,iq)/qaer0bar(i,l,iq)
+               ENDIF
+c        La tendance correspond a (qaer-qaer0)/ptimestep
                d_tr_mph(i,l,iq) = (qaer(i,l,iq)-qaer0(i,l,iq))/
      &                            ptimestep
@@ -738,20 +494,11 @@
        ELSEIF(microfi.gt.1) THEN 
          DO iq=1,nmicro
-           DO l=1,llm
-             DO i = 1, klon
-               d_tr_mph(i,l,iq)=(qaer(i,l,iq)-qaer0(i,l,iq))/ptimestep
-             ENDDO
-           ENDDO
+           d_tr_mph(:,:,iq)=(qaer(:,:,iq)-qaer0(:,:,iq))/ptimestep
          ENDDO
-
        ENDIF   ! microfi
 
        DO iq=1,nmicro
-         DO l=1,llm
-           DO i = 1, klon
 c  Traceurs microphysiques: passage en intensif: n/m^2 --> n/kg
-             d_tr_mph(i,l,iq) = d_tr_mph(i,l,iq)*RG/delp(i,l)
-           ENDDO
-         ENDDO
+         d_tr_mph(:,:,iq) = d_tr_mph(:,:,iq)*RG/delp(:,:)
        ENDDO
 
@@ -764,20 +511,8 @@
 
       DO iq=nmicro+1,nqmax
-         DO l=1,llm
-            d_tr_kim(1,l,iq) = pdyfi(1,l,iq-nmicro)
-            d_tr_mph(1,l,iq) = zdqmufi(1,l,iq)
-            ig0          = 2
-            DO j=2,jjm
-               DO i = 1, iim
-                  d_tr_kim(ig0,l,iq)  = pdyfi(j,l,iq-nmicro)
-     &                 *tr_seri(ig0,l,iq)/ychim(j,l,iq-nmicro)
-                  d_tr_mph(ig0,l,iq)  = zdqmufi(j,l,iq)
-     &                 *tr_seri(ig0,l,iq)/ychim(j,l,iq-nmicro)
-                  ig0             = ig0 + 1
-               ENDDO
-            ENDDO
-            d_tr_kim(ig0,l,iq) = pdyfi(jjm+1,l,iq-nmicro)
-            d_tr_mph(ig0,l,iq) = zdqmufi(jjm+1,l,iq)
-         ENDDO
+         d_tr_kim(:,:,iq) = pdyfi(:,:,iq-nmicro)
+     &             *tr_seri(:,:,iq)/ychim(:,:,iq-nmicro)
+         d_tr_mph(:,:,iq) = zdqmufi(:,:,iq)
+     &             *tr_seri(:,:,iq)/ychim(:,:,iq-nmicro)
       ENDDO
 
@@ -792,34 +527,14 @@
 c les especes concernees (CH4, C2H6 pour le moment). 
        IF (microfi.ge.1.and.clouds.eq.1) THEN
-         DO i=1,klon
-           DO l=1,klev
 c     condensation CH4
-             d_tr_mph(i,l,icldch4)=(gaz1(i,l)-tr_seri(i,l,icldch4))
+          d_tr_mph(:,:,icldch4) =(gaz1(:,:)-tr_seri(:,:,icldch4))
      &                            /ptimestep
 c     condensation C2H6
-             d_tr_mph(i,l,icldc2h6)=(gaz2(i,l)-tr_seri(i,l,icldc2h6))
-     &                             /ptimestep
+          d_tr_mph(:,:,icldc2h6)=(gaz2(:,:)-tr_seri(:,:,icldc2h6))
+     &                            /ptimestep
 c     condensation C2H2
-             d_tr_mph(i,l,icldc2h2)=(gaz3(i,l)-tr_seri(i,l,icldc2h2))
-     &                             /ptimestep
-           ENDDO 
-         ENDDO
+          d_tr_mph(:,:,icldc2h2)=(gaz3(:,:)-tr_seri(:,:,icldc2h2))
+     &                            /ptimestep
        ENDIF
-c        ch4c=0.
-c       do l=1,llm
-c       ch4c(1,l) = tr_seri(1,l,icldch4)
-c       do j=2,jjm
-c         ig0=1+(j-2)*iim
-c         do i=1,iim
-c            ch4c(j,l)= ch4c(j,l)+tr_seri(ig0+i,l,icldch4)/iim
-c         enddo
-c       enddo
-c        ch4c(jjm+1,l) = tr_seri(klon,l,icldch4)
-c      enddo
-c       do l=1,llm
-c         write(500,*) pplay(25,l),ch4c(25,l)
-c       enddo
-c       write(500,*) ""
-
 
 c--------------------------------------------------
@@ -882,7 +597,7 @@
            DO j=1,klev 
              DO iq=1,nrad
-*      Rayon minimum selon la quantité de noyaux
-               IF (qaer(i,j,iq+nrad) .le.   1.e-5) THEN
-                  rcloud(i,j,iq) = 1.e-10
+*      Rayon minimum selon la quantite de noyaux
+               IF (qaer(i,j,iq+nrad) .le. 1.e-5) THEN
+                 rcloud(i,j,iq) = 1.e-10
                ELSE
                  rcloud(i,j,iq)=
@@ -940,6 +655,6 @@
 c
 c      OCCCLD
-c      Calcul le nombre d'occurence d'un nuage 
-c      d opacité comprise en kmin et kmax
+c      Calcul le nombre d occurence d un nuage 
+c      d opacite comprise en kmin et kmax
 c          k        kmin            kmax
 c          1   0.0000000      0.10000000    
Index: trunk/LMDZ.TITAN/libf/phytitan/radlwsw.F
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/radlwsw.F	(revision 1055)
+++ trunk/LMDZ.TITAN/libf/phytitan/radlwsw.F	(revision 1056)
@@ -1,9 +1,4 @@
-      SUBROUTINE radlwsw(dist, rmu0, fract, falbe, zzlev,
-     .                  paprs, pplay,tsol, pt, nq, nmicro, pq,
-     .                  qaer,
-     .                  heat,cool,radsol,
-     .                  topsw,toplw,solsw,sollw,
-     .                  sollwdown,
-     .                  lwnet, swnet)
+      SUBROUTINE radlwsw(dist, rmu0, fract, zzlev,
+     .                  paprs, pplay,tsol, pt, nq, nmicro, pq,qaer)
 c      
 c======================================================================
@@ -41,5 +36,8 @@
       use dimphy
       USE comgeomphy
-      IMPLICIT none
+      USE phys_state_var_mod, only: falbe,heat,cool,radsol,
+     .      topsw,toplw,solsw,sollw,sollwdown,lwnet,swnet
+      USE write_field_phy
+       IMPLICIT none
 #include "dimensions.h"
 #include "YOMCST.h"
@@ -48,5 +46,5 @@
 c ARGUMENTS
       INTEGER nq,nmicro
-      real rmu0(klon), fract(klon), falbe(klon), dist
+      real rmu0(klon), fract(klon), dist
 c
       real zzlev(klon,klev+1),paprs(klon,klev+1), pplay(klon,klev)
@@ -55,9 +53,4 @@
       real pq(klon,klev,nq)
       REAL qaer(klon,klev,nq)
-      real heat(klon,klev), cool(klon,klev)
-      real radsol(klon), topsw(klon), toplw(klon)
-      real solsw(klon), sollw(klon)
-      real sollwdown(klon)
-      REAL swnet(klon,klev+1),lwnet(klon,klev+1)
 c
 c LOCAL VARIABLES
@@ -87,4 +80,7 @@
              enddo
 
+c     call WriteField_phy('radlwsw_zp',zp,klev+1)
+
+c =======================================
 c   altitudes (m) avec indice 1 en haut
              do l=1,klev+1
@@ -121,5 +117,4 @@
          CALL radtitan(zp,nq,nmicro,zq,qaer)
 
-c =======================================
 c CALCUL DU SW 
 c =======================================
Index: trunk/LMDZ.TITAN/libf/phytitan/radtitan.F
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/radtitan.F	(revision 1055)
+++ trunk/LMDZ.TITAN/libf/phytitan/radtitan.F	(revision 1056)
@@ -35,4 +35,5 @@
       USE comgeomphy
       USE optcld, only : iniqcld
+      use moyzon_mod, only:plevmoy
       IMPLICIT NONE
 #include "dimensions.h"
@@ -118,5 +119,4 @@
       IPRINT=1
 
-C MODIFY ADJUSTABLE NUMBERS HERE -- NOT IN COMMON
 C&&
       FHAZE=0.3
@@ -124,17 +124,7 @@
        if(iprem.eq.0) then
          TAUFAC=0
-         FHVIS=2.0
-         FHIR=.2
-       print*,'ouverture du fichier initpar'
-       open (unit=1,file='initpar')
-       read(1,*) xpoub,kkk,xvis,xir
-       close(1)
-         FHVIS= xvis
-         FHIR = xir
-       print*,'ouverture du fichier initpar ok'
-       print*,'DANS RADTITAN'
-       print*,'-------------'
-       print*,'FHVIS  = ',FHVIS
-       print*,'FHIR   = ',FHIR
+c xvis et xir lus dans physiq.def  (ancien fichier initpar)
+       FHVIS= xvis
+       FHIR = xir
 c      on initialise le paquet optcld
        if (clouds.eq.1) call iniqcld()
@@ -151,7 +141,11 @@
        print*,notfirstcall
 
-      DO 210 J=1,NLEVEL
-         PRESS(J)=SSUM(klon,p(1,j),1)/FLOAT(klon)
+c   pression moyenne globale
+c   passage au pressions en bar avec indice 1 au sommet.
+c   (similaire zp dans radlwsw)
+      DO 210 J=2,NLEVEL
+         PRESS(J)=plevmoy(NLEVEL+1-j)*1.e-5
 210   CONTINUE
+      PRESS(1) = PRESS(2)*0.001
 
 c  a cause du tableau predefini dans lell.F (et lell_light.F)
Index: trunk/LMDZ.TITAN/libf/phytitan/rcm1d.F
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/rcm1d.F	(revision 1055)
+++ trunk/LMDZ.TITAN/libf/phytitan/rcm1d.F	(revision 1056)
@@ -85,4 +85,5 @@
       COMMON/cpdetvenus/cppdyn,nu_venus,t0_venus
       REAL cppdyn,nu_venus,t0_venus
+      real pi
 
 c=======================================================================
@@ -175,4 +176,5 @@
       ndt=ndt*day_step     
       dtphys=daysec/day_step  
+      dtime=dtphys
 
 c Pression de surface sur la planete
